<div class='ptx__tax'>
    <app-loading *ngIf="isLoadingPage"></app-loading>
    <app-personal-information
        [isSubmitted]='isSubmitted'
        [form]='form'
        (getEmployee)='getEmployee($event)'
        [isShowTaxNo]='isShowTaxNo'
        [isCheckEmployeeNotHaveTaxNumber]="true"
        [functionCode]="functionCode"
    ></app-personal-information>
    <form nz-form [formGroup]="form" style='margin-top: 20px'>
        <div nz-row [nzGutter]='[30,30]'>

            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="listPaperType"
                    (mbEventEmit)="onPaperTypeChange($event)"
                    mbKeyLabel="label"
                    mbKeyValue="value"

                    mbLabelText="{{'personalTax.taxRegisters.paperTypeLabel' | translate}}  <span class='label__required'>*</span>"
                    [formControlName]="'idTypeCode'"


                    [mbType]="isSubmitted && form.controls['idTypeCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['idTypeCode'].errors !== null"
                    [mbErrors]="form.controls['idTypeCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.paperTypeRequired' | translate } ]"
                ></mb-select>
            </div>

            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-input-text
                    mbLabelText="{{'personalTax.taxRegisters.numberLabel' | translate}} <span class='label__required'>*</span>"
                    mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                    [formControlName]="'idNo'"

                    [mbDisable]="form.controls['idTypeCode'].value === '' || isDetail"

                    [mbType]="isSubmitted && form.controls['idNo'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['idNo'].errors !== null"
                    [mbErrors]="form.controls['idNo'].errors"
                    [mbErrorDefs]="[
                         { errorName: 'required', errorDescription: 'personalTax.taxRegisters.numberRequired' | translate },
                         { errorName: 'number', errorDescription: 'personalTax.taxRegisters.idNoMustNumber' | translate },
                         { errorName: 'idNoOnlyAccept9Number', errorDescription: 'personalTax.taxRegisters.idNoOnlyAccept9Number' | translate },
                         { errorName: 'citizenOnlyAccept12Number', errorDescription: 'personalTax.taxRegisters.citizenOnlyAccept12Number' | translate }
                    ]"
                ></mb-input-text>
            </div>

            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-date-picker
                    mbLabelText="{{'personalTax.taxRegisters.dateIssueLabel' | translate}} <span class='label__required'>*</span>"
                    [mbPlaceholderText]="'dd/mm/yyyy'"
                    [formControlName]="'idDate'"

                    [mbDisabled]="form.controls['idTypeCode'].value === '' || isDetail"

                    [mbType]="isSubmitted && form.controls['idDate'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['idDate'].errors !== null"
                    [mbErrors]="form.controls['idDate'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.dateIssueRequired' | translate } ]"
                ></mb-date-picker>
            </div>

            <!-- Neu la cccd -> show -->
            <div nz-col [nzXs]="24" [nzLg]="6" *ngIf="this.form.controls['idTypeCode'].value === constant.PAPERS_CODE.ID_NO || this.form.controls['idTypeCode'].value === citizenPaperTypeValue; else other">
              <mb-select
                mbLabelText="{{'personalTax.taxRegisters.placeIssueLabel' | translate}} <span class='label__required'>*</span>"
                formControlName="idPlaceCode"
                (mbEventEmit)="selectIdPlace($event)"

                [mbDataSelects]="listCitizenPlace"
                mbKeyLabel="label"
                mbKeyValue="value"

                [mbType]="isSubmitted && form.controls['idPlaceCode'].errors ? 'error' : 'default'"
                [mbShowError]="isSubmitted && form.controls['idPlaceCode'].errors !== null"
                [mbErrors]="form.controls['idPlaceCode'].errors"
                [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.placeIssueRequired' | translate } ]"
              ></mb-select>
            </div>
            <ng-template #other>
              <!-- Neu khac cccd -> show -->
              <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-input-text
                  mbLabelText="{{'personalTax.taxRegisters.placeIssueLabel' | translate}} <span class='label__required'>*</span>"
                  mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                  [formControlName]="'idPlace'"

                  [mbDisable]="form.controls['idTypeCode'].value === '' || isDetail"

                  [mbType]="isSubmitted && form.controls['idPlace'].errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && form.controls['idPlace'].errors !== null"
                  [mbErrors]="form.controls['idPlace'].errors"
                  [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.placeIssueRequired' | translate } ]"
                ></mb-input-text>
              </div>
            </ng-template>

        </div>


        <!--Địa chỉ theo đăng ký hộ khẩu-->
        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]="24" [nzLg]="24" class="input__group">
                <label class="input__label">{{'personalTax.taxRegisters.permanentAddressLabel' | translate}}</label>
            </div>
        </div>
        <nz-divider class="hrTag"></nz-divider>
        <!--End: Địa chỉ theo đăng ký hộ khẩu-->


        <div nz-row [nzGutter]='[30,30]'>

            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="listNational"
                    mbKeyLabel="label"
                    mbKeyValue="value"
                    [mbDisable]="true"

                    mbLabelText="{{'personalTax.taxRegisters.permanentNationCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'permanentNationCode'"


                    [mbType]="isSubmitted && form.controls['permanentNationCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['permanentNationCode'].errors !== null"
                    [mbErrors]="form.controls['permanentNationCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentNationCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="provinces" [mbIsLoading]="isLoadingProvinces"
                    (mbEventEmit)="changeProvince($event, 'HK')"

                    mbLabelText="{{'personalTax.taxRegisters.permanentProvinceCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'permanentProvinceCode'"

                    [mbType]="isSubmitted && form.controls['permanentProvinceCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['permanentProvinceCode'].errors !== null"
                    [mbErrors]="form.controls['permanentProvinceCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentProvinceCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="districts" [mbIsLoading]="isLoadingDistricts"
                    (mbEventEmit)="changeDistrict($event, 'HK')"

                    mbLabelText="{{'personalTax.taxRegisters.permanentDistrictCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'permanentDistrictCode'"

                    [mbType]="isSubmitted && form.controls['permanentDistrictCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['permanentDistrictCode'].errors !== null"
                    [mbErrors]="form.controls['permanentDistrictCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentDistrictCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="wards" [mbIsLoading]="isLoadingWards"

                    mbLabelText="{{'personalTax.taxRegisters.permanentWardCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'permanentWardCode'"

                    [mbType]="isSubmitted && form.controls['permanentWardCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['permanentWardCode'].errors !== null"
                    [mbErrors]="form.controls['permanentWardCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentWardCodeRequired' | translate } ]"
                ></mb-select>
            </div>

        </div>


        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-input-text
                    mbLabelText="{{'personalTax.taxRegisters.permanentDetailInput' | translate}} <span class='label__required'>*</span>"
                    mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                    [formControlName]="'permanentDetail'"

                    [mbType]="isSubmitted && form.controls['permanentDetail'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['permanentDetail'].errors !== null"
                    [mbErrors]="form.controls['permanentDetail'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentDetailRequired' | translate } ]"
                ></mb-input-text>
            </div>
        </div>


        <!--Địa chỉ cư trú-->
        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]="24" [nzLg]="24" class="input__group">
                <label class="input__label">{{'personalTax.taxRegisters.currentAddressLabel' | translate}}</label>
            </div>
        </div>
        <nz-divider class="hrTag"></nz-divider>
        <!--End: Địa chỉ cư trú-->


        <div nz-row [nzGutter]='[30,30]'>

            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="listNational"
                    mbKeyLabel="label"
                    mbKeyValue="value"
                    [mbDisable]="true"

                    mbLabelText="{{'personalTax.taxRegisters.currentNationCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'currentNationCode'"

                    [mbType]="isSubmitted && form.controls['currentNationCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['currentNationCode'].errors !== null"
                    [mbErrors]="form.controls['currentNationCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentNationCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="provinces" [mbIsLoading]="isLoadingProvincesCurrent"
                    (mbEventEmit)="changeProvince($event, 'HT')"
                    mbLabelText="{{'personalTax.taxRegisters.currentProvinceCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'currentProvinceCode'"

                    [mbType]="isSubmitted && form.controls['currentProvinceCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['currentProvinceCode'].errors !== null"
                    [mbErrors]="form.controls['currentProvinceCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentProvinceCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="districtsCurrent" [mbIsLoading]="isLoadingDistrictsCurrent"
                    (mbEventEmit)="changeDistrict($event, 'HT')"
                    mbLabelText="{{'personalTax.taxRegisters.currentDistrictCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'currentDistrictCode'"

                    [mbType]="isSubmitted && form.controls['currentDistrictCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['currentDistrictCode'].errors !== null"
                    [mbErrors]="form.controls['currentDistrictCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentDistrictCodeRequired' | translate } ]"
                ></mb-select>
            </div>


            <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select
                    [mbDataSelects]="wardsCurrent" [mbIsLoading]="isLoadingWardsCurrent"
                    mbLabelText="{{'personalTax.taxRegisters.currentWardCodeInput' | translate}} <span class='label__required'>*</span>"
                    [formControlName]="'currentWardCode'"

                    [mbType]="isSubmitted && form.controls['currentWardCode'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['currentWardCode'].errors !== null"
                    [mbErrors]="form.controls['currentWardCode'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentWardCodeRequired' | translate } ]"
                ></mb-select>
            </div>

        </div>


        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-input-text
                    mbLabelText="{{'personalTax.taxRegisters.currentDetailInput' | translate}} <span class='label__required'>*</span>"
                    mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                    [formControlName]="'currentDetail'"

                    [mbType]="isSubmitted && form.controls['currentDetail'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['currentDetail'].errors !== null"
                    [mbErrors]="form.controls['currentDetail'].errors"
                    [mbErrorDefs]="[ { errorName: 'required', errorDescription: 'personalTax.taxRegisters.permanentDetailRequired' | translate } ]"
                ></mb-input-text>
            </div>
        </div>


        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-input-text
                    appNumberInput
                    mbLabelText="{{'personalTax.taxRegisters.mobileNumberInput' | translate}} <span class='label__required'>*</span>"
                    [mbMaxLength]="10"

                    mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                    [formControlName]="'mobileNumber'"

                    [mbType]="isSubmitted && form.controls['mobileNumber'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['mobileNumber'].errors !== null"
                    [mbErrors]="form.controls['mobileNumber'].errors"
                    [mbErrorDefs]="[
                        { errorName: 'required', errorDescription: 'personalTax.taxRegisters.mobileNumberRequired' | translate },
                        { errorName: 'pattern', errorDescription: 'personalTax.taxRegisters.mobileNumberPatternValidate' | translate }
                    ]"
                ></mb-input-text>
            </div>

            <div nz-col [nzXs]='24' [nzLg]='6'>
                <mb-input-text
                    mbLabelText="{{'personalTax.taxRegisters.emailInput' | translate}} <span class='label__required'>*</span>"
                    mbPlaceholderText="{{'personalTax.taxRegisters.placeholder' | translate}}"
                    [formControlName]="'email'"

                    [mbType]="isSubmitted && form.controls['email'].errors ? 'error' : 'default'"
                    [mbShowError]="isSubmitted && form.controls['email'].errors !== null"
                    [mbErrors]="form.controls['email'].errors"
                    [mbErrorDefs]="[
                        { errorName: 'required', errorDescription: 'personalTax.taxRegisters.emailRequired' | translate },
                        { errorName: 'email', errorDescription: 'personalTax.taxRegisters.emailFormat' | translate },
                    ]"
                ></mb-input-text>
            </div>
        </div>


        <div nz-row [nzGutter]='[30,30]' *ngIf="isDetail && (this.taxNumberRegisterEdit?.status === constant.STATUS_OBJ.FINANCIAL_ACCOUNTANT_RETURN || this.taxNumberRegisterEdit?.status === constant.STATUS_OBJ.TAX_AUTHORITIES_RETURN)">
            <div nz-col [nzXs]='24' [nzLg]='24'>
                <mb-input-text
                    [mbIsTextAre]="true"
                    mbLabelText="{{'personalTax.taxRegisters.rejectReason' | translate}}"
                    [formControlName]="'rejectReason'"
                ></mb-input-text>
            </div>
        </div>


        <!--File đính kèm-->
        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]='24' [nzLg]='20' class="input__group">
                <label class="input__label">{{'personalTax.label.attachFile' | translate}} <span
                    class='label__required'>*</span></label>
                <span class="uploadHintText">{{'personalTax.taxRegisters.uploadHintText' | translate}}</span>

                <div class="uploadFile--wrap">

                    <nz-upload
                        [nzMultiple]=" true"
                        [(nzFileList)]="fileList"
                        [nzBeforeUpload]="beforeUpload"
                        [nzRemove]="removeFile"
                        [nzDownload]="downloadFile"
                        nzAccept=".TIF, .JPG, .GIF, .PNG, .PDF, .DOC, .DOCX, .XLS, .XLSX"
                    >

                        <button class="btnUploadFile">{{'personalTax.taxRegisters.btnUploadFile' | translate}}</button>

                    </nz-upload>
                </div>
                <div *ngIf='isSubmitted && this.fileList?.length === 0' class='input__group'>
                    <div class='input__message'>
                        <em nz-icon nzType='close-circle' nzTheme='outline'></em>
                        <span class='text__message'>{{'personalTax.validate.fileRequired' | translate}}</span>
                    </div>
                </div>
            </div>
        </div>
        <!--End: File đính kèm-->


        <!--Button Lưu lại-->
        <div nz-row [nzGutter]='[30,30]'>
            <div nz-col [nzXs]="24" [nzLg]="24" [ngStyle]="{'text-align': 'right'}">
                <mb-button *ngIf="!isDetail"
                           mbButtonSize='MEDIUM'
                           mbButtonAvailableStyle='BtnCancelHasBorder'
                           (click)="closeModalAdd()"
                           mbButtonText="{{'personalTax.dependentRegisters.cancel' | translate}}"
                ></mb-button>
                <mb-button
                  *ngIf="isDetail"
                  mbButtonSize='MEDIUM'
                  mbButtonAvailableStyle='BtnCancelHasBorder'
                  (click)="closeModalAdd()"
                  mbButtonText="{{'personalTax.dependentRegisters.back' | translate}}"
                ></mb-button>

                <mb-button
                  *ngIf="status && status === constant.STATUS_OBJ.WAIT_APPROVE && isDetail && objFunction?.approve"
                  mbButtonSize='SMALL'
                  mbButtonAvailableStyle='PRIMARY'
                  mbButtonText="{{'personalTax.label.approve' | translate}}"
                  (click)="approveById(registerId)"
                ></mb-button>
                <mb-button
                  *ngIf="status && status === constant.STATUS_OBJ.WAIT_APPROVE && isDetail && objFunction?.approve"
                  mbButtonSize='SMALL'
                  mbButtonAvailableStyle='DEFAULT'
                  (click)="openRejectForm()"
                  mbButtonText="{{'personalTax.label.reject' | translate}}"
                ></mb-button>

                <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='PRIMARY'
                           (click)="onSave()"
                           *ngIf="!isDetail"
                           mbButtonText="{{'personalTax.dependentRegisters.save' | translate}}"></mb-button>
            </div>
        </div>
        <!--End: Button Lưu lại và Gửi duyệt-->

        <app-reject-common
            [isReject]="isReject"
            [id]="registerId"
            [urlRejectByList]="urlReject"
            (onCloseModal)="doCloseReject($event)"
        >
        </app-reject-common>
    </form>
</div>
